my_tribune=$tribune[Thread.current[:name]]
my_post=my_tribune.current_post

###############################################################################
#                                FORTUNES                                     #
###############################################################################A

##maintenant, on s'occupe des fortunes
##une demande de fortune se fait sous la forme:
## "#fortune nh1-nh2 (sauf nh3, nh4, etc)
##ou
## "#fortune nh1, nh2, nh3, (nh4-nh5), nh6

##ça, c'est le(s) responsable(s) des fortunes (en string)
modos = dbh("select_all","SELECT login FROM #{my_tribune.db_prefix}blacklist WHERE fortunes = -1").join("<, ").sub(/\w+$/,'ou \0<')

##ça c'est si un modéro (n'importe qui de whitelisté pour les fortunes) force l'autorisation d'une fortune longue
##on crée simplement un autre objet Poste correspondant à la demande originale, et la demande se refait, mais sans blocage
forced_nhorloge = my_post.message.scan(/#force_fortune +(.*)/).to_s
is_forced = false
if forced_nhorloge != ""
  auth = dbh("select_one","SELECT fortunes FROM #{my_tribune.db_prefix}blacklist WHERE login = ?", my_post.login).to_s.to_i
  log("Demande de forçage de " + forced_nhorloge + " par " + my_post.login_str + "<")

  if auth == -1

    forced_id = nhorloge2post(my_tribune, forced_nhorloge, my_post.timestamp).first
    forced_post = dbh("select_one","SELECT post_id, post_time+0 AS post_time, login, info, message FROM #{my_tribune.db_prefix}posts WHERE id = ?", forced_id)

    if forced_post[:message].match("^#fortune +[0-9]")
      forced_post_xml = Element.new("post")
      forced_post_xml.add_attribute("time",forced_post[:post_time].to_i)
      forced_post_xml.add_attribute("id",forced_post[:post_id])
      forced_post_xml.add_element("info").text = forced_post[:info]
      forced_post_xml.add_element("message").text = forced_post[:message]
      forced_post_xml.add_element("login").text = forced_post[:login]
      fortune_post = Poste.new(forced_post_xml)
      is_forced = true
    else
      log("Mais ce n'était pas une demande de fortune...")
    end

  end

end


##on regarde d'abord si c'est une demande de suppression
fortune_a_virer = my_post.message.scan(Regexp.new("^#fortune +\/?remove +([0-9]*)")).to_s.to_i

if fortune_a_virer != 0
  #vire la fortune, si c'est demandé par le créateur de la fortune, et dans les 30 minutes suivant la demande
  log("(" + my_post.timestamp + ") Demande de suppression de la fortune " + fortune_a_virer.to_s + " par " + my_post.login_str + " : " + my_post.message)

  fortune = dbh("select_one","SELECT fortune_login, fortune_time FROM #{my_tribune.db_prefix}fortunes WHERE fortune_no = ?", fortune_a_virer)

  if ( fortune != nil && my_post.timestamp_Time - Time.parse(fortune[:fortune_time]) <= 1800 && my_post.login == fortune[:fortune_login] )

      dbh("do","DELETE FROM #{my_tribune.db_prefix}fortunes WHERE fortune_no = ?", fortune_a_virer)
      ##on supprime aussi les votes et commentaires éventuels pour cette fortune:
      dbh("do","DELETE FROM #{my_tribune.db_prefix}modo_votes WHERE fortune_no = ?", fortune_a_virer)
      dbh("do","DELETE FROM #{my_tribune.db_prefix}fortunes_comments WHERE fortune_no = ?", fortune_a_virer)
    
    envoi(my_tribune, my_post.nhorloge2 + " fortune " + fortune_a_virer.to_s + " supprimée.")

  else
    envoi(my_tribune, my_post.nhorloge2 + " je ne peux pas faire ça. Es-tu sûr que la fortune existe ? que tu en es l'auteur ? qu'elle a moins d'une demie-heure ? " + my_tribune.admin_login + "< tu peux jeter un oeil à ça ?")
  end



##ou une demande de fortune
elsif my_post.message.match("^#fortune +[0-9]") || is_forced
  if is_forced
    log("(" + my_post.timestamp + ") " + my_post.login_str + " a autorisé la fortune demandée par " + fortune_post.login_str + " à " + forced_nhorloge + '("' + fortune_post.message + '")' )
  else
    log("(" + my_post.timestamp + ") Nouvelle demande de fortune par " + my_post.login_str + " : " + my_post.message)
    fortune_post = my_post
  end

  liste = []
  intervalle_taille = 0
  oversize = 0

  ##on commence par séparer les éléments, entre les posts à inclure et les "sauf"
  ##on supprime d'abord l'appel à la fortune,
  ##on vire les ' :' pour être compatible avec Nedlanders^Wwmc²
  ##on supprime les espaces superfétatoires autour des '-'
  ##on remplace les espaces entre les nhorloges par des ',' (parce que Ned< et axel< sont des feignasses)
  
  ##ça c'était la version avant que nono remplace les &sup[123]; par ¹²³
  #fortune_def = post.message.sub(/#fortune ?#?/,'').sub('#','-').gsub(' :','').gsub(/ ?- ?/,'-').gsub(/([0-9]) ([0-9])/,'\1,\2').gsub(' ','').split("sauf")
  fortune_comment = fortune_post.message.split("//")[1]
  fortune_def = fortune_post.message.split("//")[0].sub(/#fortune +/,'').gsub(' :','').gsub(/ ?- ?/,'-').gsub(/([0-9]\302?[¹²³]?) +([0-9])/,'\1,\2').gsub(' ','').split("sauf")



  ##c'est la liste des posts à inclure:
  if fortune_def[0] != nil
    fortune_def[0].split(",").each{|nhorloge|
      ##si c'est un intervalle, on prend l'éventuel premier post correspondant au début, et le dernier correspondant à la fin
      if nhorloge.include?("-") && oversize == 0
        nh1 = nhorloge2post(my_tribune, nhorloge.split("-")[0], fortune_post.timestamp).first
        nh2 = nhorloge2post(my_tribune, nhorloge.split("-")[1], fortune_post.timestamp).last
        if nh1 != nil and nh2 != nil
          intervalle_taille = dbh("select_one","SELECT COUNT(id) FROM #{my_tribune.db_prefix}posts WHERE id BETWEEN ? AND ?", nh1, nh2).to_s.to_i

          if intervalle_taille < 500
            liste += dbh("select_all","SELECT id FROM #{my_tribune.db_prefix}posts WHERE id BETWEEN ? AND ?", nh1, nh2).flatten
          else
            oversize = 1
          end
        end
      ##sinon, on prend juste le post (ou plusieurs en cas de doublons)
      elsif nhorloge != "" && oversize == 0
        liste += nhorloge2post(my_tribune, nhorloge, fortune_post.timestamp).flatten
      end
    }
  end

  ##on prend en compte les "sauf"
  if fortune_def[1] != nil && oversize == 0
    fortune_def[1].split(",").each{|nhorloge|
      if nhorloge.include?("-") && oversize == 0
        nh1 = nhorloge2post(my_tribune, nhorloge.split("-")[0], fortune_post.timestamp).first
        nh2 = nhorloge2post(my_tribune, nhorloge.split("-")[1], fortune_post.timestamp).last
        if nh1 != nil and nh2 != nil
          intervalle_taille = dbh("select_one","SELECT COUNT(id) FROM #{my_tribune.db_prefix}posts WHERE id BETWEEN ? AND ?", nh1, nh2).to_s.to_i

          if intervalle_taille < 500
            liste -= dbh("select_all","SELECT id FROM #{my_tribune.db_prefix}posts WHERE id BETWEEN ? AND ?", nh1, nh2).flatten
          else
            oversize = 1
          end
        end
      elsif nhorloge != "" && oversize == 0
        liste -= nhorloge2post(my_tribune, nhorloge, fortune_post.timestamp).flatten
      end
    }
  end

  ##on met tous ces id en ordre, et on vire les doublons éventuels
  liste = liste.flatten.sort.uniq

  ##s'il n'y a rien, ou trop, on le dit à l'expéditeur
  if oversize == 1
    envoi(my_tribune, my_post.nhorloge2 + " L'intervalle est trop long (" + intervalle_taille.to_s + "),où alors je suis buggé. " + my_tribune.admin_login + "< tu peux jeter un oeil à ça ?")
  elsif liste.size == 0
    envoi(my_tribune, fortune_post.nhorloge2 + " On dirait qu'il n'y a rien. Soit je suis buggé, soit tu t'es planté. " + my_tribune.admin_login + "< tu peux jeter un oeil à ça?")
  ##si c'est trop long aussi (sauf si c'est un modéro qui force la fortune)
  elsif liste.size > 100 && is_forced == false
    envoi(my_tribune, fortune_post.nhorloge2 + " " + liste.size.to_s + " messages? Ça fait un peu beaucoup pour une fortune, non? Si c'est vraiment important, demande à " + modos + " de l'ajouter")

  ##dans le cas contraire, on insère la fortune dans la table
  else
    fortune_no = dbh("select_one","SELECT MAX(fortune_no) FROM #{my_tribune.db_prefix}fortunes")[0].to_i.+(1)
    liste.each{|id|
      dbh("do","INSERT INTO #{my_tribune.db_prefix}fortunes (fortune_no, fortune_login, fortune_time, id, post_id, post_time, doublon, seul, login, info, message) SELECT ?, ?, ?, id, post_id, post_time, doublon, seul, login, info, message FROM #{my_tribune.db_prefix}posts WHERE id = ?", fortune_no, fortune_post.login, fortune_post.timestamp, id)
    }

    ##on ajoute le commentaire:
    if fortune_comment != nil
      dbh("do","INSERT INTO #{my_tribune.db_prefix}fortunes_comments (login, fortune_no, date, message, is_titre) VALUES (?,?,?,?,1)", fortune_post.login, fortune_no, fortune_post.timestamp, fortune_comment.sub(/^ */,""))
    end


    ##on poste un petit mot
    log("C'est la fortune numéro " + fortune_no.to_s)
    if is_forced
      envoi(my_tribune, my_post.nhorloge2 + " (et " + forced_nhorloge  + ") " + my_tribune.webroot + "fortunes.rhtml?id=" + fortune_no.to_s)
    else
      envoi(my_tribune, my_post.nhorloge2 + " " + my_tribune.webroot + "fortunes.rhtml?id=" + fortune_no.to_s)
    end
    #envoi(my_tribune, my_post.nhorloge2 + " fortune en cours de modération (numéro: " + fortune_no.to_s + ")")
  end
 
end ##fin de la gestion des fortunes
