my_tribune=$tribune[Thread.current[:name]]
my_post=my_tribune.current_post
###############################################################################
#                                 BLACKLIST                                   #
###############################################################################

#on définit la regexp d'une demande de blacklist
blacklist_regexp = Regexp.new('^#blacklist +(\w+) +(\+|-|\*)(\w+\$?\w+)')
plusmoins = { "+" => "1" , "-" => "0" , "*" => "-1"}

##ici, on s'occupe des ajouts/retraits dans la blacklist
##le message à envoyer est de la forme: "#blacklist moule (+|-)module"
if my_post.message =~ blacklist_regexp
  nouvel_ajout = my_post.message.scan(blacklist_regexp)

  dbh("do","INSERT INTO #{my_tribune.db_prefix}blacklist (login, #{nouvel_ajout[0][2]}) VALUES (?,?) ON DUPLICATE KEY UPDATE #{nouvel_ajout[0][2]} = VALUES(#{nouvel_ajout[0][2]})  ", nouvel_ajout[0][0] , plusmoins[nouvel_ajout[0][1]])

  log("(" + my_post.timestamp + ") " + nouvel_ajout[0][0] + " blacklisté pour " + nouvel_ajout[0][2] + " à " + plusmoins[nouvel_ajout[0][1]].to_s + " par " + my_post.login)

end
