my_tribune=$tribune[Thread.current[:name]]
my_post=my_tribune.current_post

#C'est la partie de la chasse qui prend en compte tout le monde (saleté d'anonyme... on ne peut quand même pas les ignorer tout le temps

##si le post précédent était le seul de la minute ou était un doublon, on met à jour la liste des coincoins
if my_post.post_seul != nil
  dbh("do","UPDATE #{my_tribune.db_prefix}coincoins SET seul = 1 WHERE post_id = ?", my_post.post_seul)

elsif my_post.doublon == 2
  dbh("do","UPDATE #{my_tribune.db_prefix}coincoins SET doublon = 1 WHERE post_id = ?", my_post.premier_doublon)
end



###############################################################################
#                         NETTOYAGE DES COINCOINS                             #
###############################################################################

##maintenant, on nettoie les vieux canard (plus de 300 s)
##si le posteur du message arrivant après les 5 minutes n'est pas le posteur du canard, ce dernier chope un
##bonus de 10 points pour avoir sauvé son canard
##Il faut quand même qu'il y ait moins de 10 minutes (sinon, on envoie plein de coincoins à 4h du mat, et voila!)

liste_coin = dbh("select_all","SELECT id, post_time, login, TIME_TO_SEC( TIMEDIFF(?, post_time)) AS age FROM #{my_tribune.db_prefix}coincoins HAVING age > 300", my_post.timestamp)

liste_coin.each {|coin|
    
  dbh("do","DELETE FROM #{my_tribune.db_prefix}coincoins WHERE id = ?", coin[:id])

  if ( coin[:login] != my_post.login and coin[:age] < 601 )
    quoi="sauve"
    points=10

    dbh("do","UPDATE #{my_tribune.db_prefix}chasseurs SET survie = survie + 1 , points = points + 10 WHERE login = ?", coin[:login])
    
  else
    quoi="parti"
    points=0
  end

  ##et on ajoute tout ça aux logs
  dbh("do","INSERT INTO #{my_tribune.db_prefix}chasse_log (post_time, login, quoi, points, cible) VALUES (?,?,?,?,?)", my_post.timestamp, coin[:login], quoi, points, coin[:post_time])


} ##fin du nettoyage des canards
